#!/bin/bash

#script published by hitsteps.com on 31 Jan 2016.
#feel free to edit it and enhance it :) and do everything you want with it.

key="YOURKEY" #your cloudflare key
user="YOUR@EMAIL.COM" #your cloudflare email
notifyemail="YOUR@EMAIL.COM" #to receive notifications from this script
backupip="123.456.789.000" #your backup server IP
domain="hitsteps.com" #your domain
domain2="www.hitsteps.com" #your domain 2
srvceMode="1" #Status of CloudFlare Proxy, 1 = orange cloud, 0 = grey cloud.



wget -q --tries=1 --timeout=20 http://www.google.com -O /tmp/google >> /dev/null
if [ ! -s /tmp/google ];then
       echo `date` Internet disconnected? Not switching over! >> /hitsteps/cloudflare/switch.log
	exit 0
else

#Start check if in backup mode
if [ -f /hitsteps/cloudflare/backupactive ];
then
    echo "already in backup mode!"
    exit 0
fi
cd /hitsteps/cloudflare

function rec_load_all() {

curl https://www.cloudflare.com/api_json.html \
  -d 'a=rec_load_all' \
  -d "tkn=$key" \
  -d "email=$user" \
  -d "z=$1" -s | python -mjson.tool > results.txt
}

#$1 = searching for that zone's dns ID
function getDNSID() {
	dnsLineNum=`grep -E "\"name\": \"$1\"" -n results.txt | head -n 1 |  cut -d ":" -f1`;
	echo "dns line #:$dnsLineNum";
	dnsIDLineNum=`echo "$dnsLineNum + 13" | bc -q`;
	echo "dns id line #: $dnsIDLineNum";
	DNSID=`sed -n "$dnsIDLineNum p" results.txt | cut -d ":" -f2 | sed "s/\"//g;s/ //;s/\,//";`
}



#$1=target domain
#$2=name of the DNS record
#$3=new ip address
#$4=service mode

function edit_rec() {
echo "DNSID: $DNSID";
curl -s https://www.cloudflare.com/api_json.html \
  -d 'a=rec_edit' \
  -d "tkn=$key" \
  -d "id=$DNSID" \
  -d "email=$user" \
  -d "z=$1" \
  -d "type=A" \
  -d "name=$2" \
  -d "content=$3" \
  -d "service_mode=$4" \
  -d "ttl=1" ; #| grep '"result":"success"';

if [ $? -eq 0 ] 
then
	sleep 0;
	echo `date` "successfully changed servers to $backupip" >> /hitsteps/cloudflare/switch.log
fi
}


echo "Switching to backup..."
touch /hitsteps/cloudflare/backupactive

# old script. deprecated
# curl https://www.cloudflare.com/api_json.html -d "a=DIUP" -d "email=$user" -d "tkn=$key" -d "ip=$backupip" -d "hosts=$site" | python -mjson.tool

rec_load_all "$domain";
getDNSID "$domain";
edit_rec "$domain" "$domain" "$backupip" "$srvceMode";
getDNSID "$domain2";
edit_rec "$domain" "$domain2" "$backupip" "$srvceMode";

echo "$domain changed to backup Server"|mail -s "$domain changed to backup Server" $notifyemail

echo `date` going down! >> /hitsteps/cloudflare/switch.log
fi
exit 0
